Package: groovy.servlet

## [Java] Class ServletBinding

- groovy.servlet.ServletBinding

- Servlet-specific binding extension to lazy load the writer or the output stream from the response.

  ### Eager variables

  - `"request"` : the `HttpServletRequest` object
  - `"response"` : the `HttpServletRequest` object
  - `"context"` : the `ServletContext` object
  - `"application"` : same as context
  - `"session"` : shorthand for `request.getSession(`false`)` - can be null!
  - `"params"` : map of all form parameters - can be empty
  - `"headers"` : map of all `request` header fields

  ### Lazy variables

  - `"out"` : `response.getWriter()`
  - `"sout"` : `response.getOutputStream()`
  - `"html"` : `new MarkupBuilder(response.getWriter())` - `expandEmptyElements` flag is set to true
  - `"json"` : `new JsonBuilder()`
  As per the Servlet specification, a call to `response.getWriter()` should not be done if a call to `response.getOutputStream()` has already occurred or the other way around. You may wonder then how the above lazy variables can possibly be provided - since setting them up would involve calling both of the above methods. The trick is catered for behind the scenes using lazy variables. Lazy bound variables can be requested without side effects; under the covers the writer and stream are wrapped. That means `response.getWriter()` is never directly called until some output is done using 'out' or 'html'. Once a write method call is done using either of these variable, then an attempt to write using 'sout' will cause an `IllegalStateException`. Similarly, if a write method call on 'sout' has been done already, then any further write method call on 'out' or 'html' will cause an `IllegalStateException`.

  ### Reserved internal variable names (see "Methods" below)

  - `"forward"`
  - `"include"`
  - `"redirect"`
  If `response.getWriter()` is called directly (without using out), then a write method call on 'sout' will not cause the `IllegalStateException`, but it will still be invalid. It is the responsibility of the user of this class, to not to mix these different usage styles. The same applies to calling `response.getOutputStream()` and using 'out' or 'html'.

  ### Methods

  - `"forward(String path)"` : `request.getRequestDispatcher(path).forward(request, response)`
  - `"include(String path)"` : `request.getRequestDispatcher(path).include(request, response)`
  - `"redirect(String location)"` : `response.sendRedirect(location)`
  Authors:
    Guillaume Laforge
    Christian Stein
    Jochen Theodorou

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `String` | `variable`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `def` | `ServletBinding(HttpServletRequest request, HttpServletResponse response, ServletContext context)` Initializes a servlet binding.
    `` | `void` | `forward(String path)`
    `` | `Object` | `getVariable(String name)` @return a writer, an output stream, a markup builder or another requested object
    `` | `Map` | `getVariables()`
    `` | `void` | `include(String path)`
    `` | `void` | `redirect(String location)`
    `` | `void` | `setVariable(String name, Object value)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Binding` | `getProperty, getVariable, getVariables, hasVariable, setProperty, setVariable`
    `class GroovyObjectSupport` | `getMetaClass, getProperty, invokeMethod, setMetaClass, setProperty`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Property Detail

    - #### String variable

  - ### Method Detail

    - #### public def ServletBinding(HttpServletRequest request, HttpServletResponse response, ServletContext context)

      Initializes a servlet binding.

      Parameters:
        `request` - the HttpServletRequest object
        `response` - the HttpServletRequest object
        `context` - the ServletContext object

    - #### public void forward(String path)

    - #### @Override public Object getVariable(String name)

      Returns:
        a writer, an output stream, a markup builder or another requested object

    - #### @Override public Map getVariables()

    - #### public void include(String path)

    - #### public void redirect(String location)

    - #### @Override public void setVariable(String name, Object value)